<!--
~    Copyright (c) 2022, WSO2 Inc. (http://www.wso2.com). All Rights Reserved.
~
~    This software is the property of WSO2 Inc. and its suppliers, if any.
~    Dissemination of any information or reproduction of any material contained
~    herein in any form is strictly forbidden, unless permitted by WSO2 expressly.
~    You may not alter or remove any copyright or other notice from copies of this content."
-->

<%@ page language="java" contentType="text/html; charset=ISO-8859-1" pageEncoding="ISO-8859-1"%>
<%@ page import="static org.wso2.carbon.identity.core.util.IdentityUtil.getServerURL" %>

<%
    String serverUrl = getServerURL("", true, true);
    String authorizationCode = request.getParameter("code");
    String authSessionState = request.getParameter("session_state");
    String authIdPs = request.getParameter("AuthenticatedIdPs");
%>

<!DOCTYPE HTML>
<html>
    <head>
        <script src="https://unpkg.com/@asgardeo/auth-spa@0.2.19/dist/asgardeo-spa.production.min.js"></script>
    </head>
    <body>
        <script>
            var userAccessedPath = window.location.href;
            var applicationDomain = window.location.origin;

            var userTenant = userAccessedPath.split("/t/")[1] ?  userAccessedPath.split("/t/")[1].split("/")[0] : null;
            userTenant = userTenant ?  userTenant.split("?")[0] : null;

            var serverOrigin = "<%=serverUrl%>";
            var authorizationCode = "<%=authorizationCode%>" != "null" ? "<%=authorizationCode%>" : null;
            var authSessionState = "<%=authSessionState%>" != "null" ? "<%=authSessionState%>" : null;
            var authIdPs = "<%=authIdPs%>" != "null" ? "<%=authIdPs%>" : null;
            
            function getApiPath(path) {
                if(path) {
                    return serverOrigin + path;
                }

                return serverOrigin;
            }
            
            var auth = AsgardeoAuth.AsgardeoSPAClient.getInstance();

            var authConfig = {
                signInRedirectURL: applicationDomain.replace(/\/+$/, ''),
                signOutRedirectURL: applicationDomain.replace(/\/+$/, ''),
                clientID: "CONSOLE",
                serverOrigin: getApiPath(),
                responseMode: "form_post",
                scope: ["openid SYSTEM"],
                storage: "webWorker",
                endpoints: {
                    authorizationEndpoint: getApiPath(userTenant ? "/t/a/oauth2/authorize?ut="+userTenant.replace(/\/+$/, '') : "/t/a/oauth2/authorize"),
                    clockTolerance: 300,
                    jwksEndpointURL: undefined,
                    logoutEndpointURL: getApiPath("/t/a/oidc/logout"),
                    oidcSessionIFrameEndpointURL: getApiPath("/t/a/oidc/checksession"),
                    serverOrigin: getApiPath(),
                    tokenEndpointURL: undefined,
                    tokenRevocationEndpointURL: undefined,
                    wellKnownEndpointURL: undefined,
                },
                enablePKCE: true,
                overrideWellEndpointConfig: true
            }

            var isSilentSignInDisabled = userAccessedPath.includes("disable_silent_sign_in");
            var isTenantSwitchPath = userAccessedPath.includes("switch_tenant");
            
            if(isSilentSignInDisabled) {

                if(isTenantSwitchPath) {
                    auth.initialize(authConfig);
                    auth.signIn();
                } else {
                    window.location = applicationDomain+'/authenticate?disable_silent_sign_in=true&invite_user=true';
                }
            } else {

                if(authorizationCode) {
                    sessionStorage.setItem("userAccessedPath", userAccessedPath.split(window.origin)[1]);

                    window.location = applicationDomain+'/authenticate?code='+authorizationCode+'&state=sign-in-silently'+'&AuthenticatedIdPs='+authIdPs+
                                '&session_state='+authSessionState;
                } else {
                    sessionStorage.setItem("auth_callback_url_console", 
                        userAccessedPath.split(window.origin)[1] 
                            ? userAccessedPath.split(window.origin)[1].replace(/\/+$/, '') : null);
                    auth.initialize(authConfig);
                    auth.signIn();
                }
            }
        </script>
    </body>
</html>

